from django.db import models
from django.contrib.contenttypes.fields import GenericForeignKey
from django.contrib.contenttypes.fields import GenericRelation
from django.contrib.contenttypes.models import ContentType


class SmartModule(models.Model):
    name = models.CharField(max_length=50, verbose_name='模块名称')
    desc = models.CharField(max_length=200, verbose_name='简介')
    content_type = models.ForeignKey(ContentType, on_delete=models.CASCADE)
    object_id = models.PositiveIntegerField()
    content_object = GenericForeignKey('content_type', 'object_id')
    device_id = models.CharField(max_length=100, verbose_name='模块ID')
    chip_id = models.CharField(max_length=100, verbose_name='单片机ID')

    class Meta:
        verbose_name = '智能模块'
        verbose_name_plural = verbose_name

    def __str__(self):
        return self.name
